<template>
  <single-pane capt="требования к сервису и безопасности">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :items="items"
      :show-add-button="true"
      @select="onSelectionItem"
      @add="onAdd"
      ref="obTable"
    />

    <ob-modal
      ref="viewItem"
      custom-class="modal-extra-large"
      title="Требование к сервису и безопасности"
      :titleSecond="newStatus ? 'Добавление' : 'Редактирование'"
      :is-show-pagination="!newStatus"
      @onСhangeActive="alert('test')"
    >
      <service-item
        :data-source="selectedData"
        :isShowControls="true"
        :activites="activites"
        @delete="onDelete"
        @submit="onSave"
      />
    </ob-modal>

    <ob-modal
      ref="deleteItem"
      :edit-form="false"
      :isError="true"
      size="large"
      :title="`Удалить запись «${selectedData.title}»`"
      ok-text="Да, удалить"
      cancel-text=" Оставить"
      :is-show-controls="true"
      @submit="onConfirmDelete"
    >
      <p>
        Запись «{{ selectedData.title }}» будет удалена из справочника
        «Требования к сервису и безопасности» без возможности восстановления.
        Связанные с этим элементом записи в подчиненных справочниках будут деактивированы.
      </p>
    </ob-modal>
  </single-pane>
</template>

<script>
import api from '@/api';
import paging from '@/mixins/dictionaries/paging';
import itemMixin from '@/mixins/dictionaries/edit-item';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable from 'common-components/src/obComponents/obTable';
import ObModal from 'common-components/src/obComponents/obModal';
import ServiceItem from './modal/serviceItem';
export default {
  name: 'serviceAndSecurity',

  components: {
    ObModal,
    ObTable,
    SinglePane,
    ServiceItem,
  },

  mixins: [
    itemMixin,
    paging,
  ],

  data() {
    return {
      activites: [],
      api: {
        source: '/oboz2-dictionary-service-types-crud/v1/'
      },
      selectedData: '',
      items: [
        {
          uuid       : 1,
          title      : 'Белый халат',
          description: 'Тут будет описание. Cложившаяся структура организации не позволяет',
          isActive   : true
        },
        {
          uuid       : 2,
          title      : 'Противооткатные башмаки',
          description: 'Описание. Повседневная практика показывает, что начальство.',
          isActive   : true
        },
        {
          uuid       : 3,
          title      : 'Распределение по осям',
          description: 'Это описание. Разнообразный и богатый опыт начальствования',
          isActive   : false
        }
      ]
    }
  },

  created() {
    this.fetch();
  },

  computed: {
    columnsObTable() {
      return [
        {
          title: 'Наименование',
          key: 'title'
        },
        {
          title: 'Описание',
          key: 'description',
          html: function({ description }) {
            if (description.length >= 50) return `${description.slice(0, 50)}...`;

            return description;
          }
        },
        {
          title: 'Статус',
          width: 110,
          key: 'isActive',
          html: data => !data.isActive ? 'Неактивно' : 'Активно'
        }
      ]
    }
  },

  methods: {
    async fetch() {
      try {
        const res = await api.services.getServiceRequirements();
        this.items = res;
      }
      catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },

    onAdd() {
      this.newStatus = true;
      this.selectedData = {
        title: '',
        description: '',
        isActive: false
      };
      this.$refs.viewItem.open();
    },

    async onSelectionItem(data) {
      this.newStatus = false;
      this.selectedData = data;
      this.$refs.viewItem.open();
    },

    async onSave(e) {
      if (this.newStatus) {
        this.selectedData = e;
        const payload = {
          title: e.title,
          description: e.description,
          isActive: e.isActive
        };
        try {
          await api.services.createServiceRequirements(payload);
          this.$refs.viewItem.close();
          this.$notification({
            type: 'system_notification_success',
            message: this.newStatus
              ? `Запись «${this.selectedData.title}» добавлена`
              : `Запись «${this.selectedData.title}» сохранена`
            });
          this.fetch();
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      }
      else {
        try {
          await api.services.editServiceRequirements(e.uuid, e);
          this.$refs.viewItem.close();
          this.$notification({
            type: 'system_notification_success',
            message: this.newStatus
              ? `Запись «${this.selectedData.title}» добавлена`
              : `Запись «${this.selectedData.title}» обновлена`
            });
          this.fetch();
        } catch (e) {
          console.error(e);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }
      }
    },

    onDelete() {
      this.$refs.deleteItem.open();
    },

    async onConfirmDelete() {
      try {
        await api.services.deleteServiceRequirements(this.selectedData.uuid)
        this.$refs.deleteItem.close();
        this.$refs.viewItem.close();
        this.$notification({
          type: 'system_notification_success',
          message: `Запись «${this.selectedData.title}» удалена  и перенесена в «Архив»`
        });
        await this.fetch();
      }
      catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка при удалении записи «${this.selectedData.title}»`
        });
      }
    }
  }
}
</script>